package com.lightinit.hsdataportal.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class RequirementApiExample extends BaseExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public RequirementApiExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andSystemNameIsNull() {
            addCriterion("system_name is null");
            return (Criteria) this;
        }

        public Criteria andSystemNameIsNotNull() {
            addCriterion("system_name is not null");
            return (Criteria) this;
        }

        public Criteria andSystemNameEqualTo(String value) {
            addCriterion("system_name =", value, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameNotEqualTo(String value) {
            addCriterion("system_name <>", value, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameGreaterThan(String value) {
            addCriterion("system_name >", value, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameGreaterThanOrEqualTo(String value) {
            addCriterion("system_name >=", value, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameLessThan(String value) {
            addCriterion("system_name <", value, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameLessThanOrEqualTo(String value) {
            addCriterion("system_name <=", value, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameLike(String value) {
            addCriterion("system_name like", value, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameNotLike(String value) {
            addCriterion("system_name not like", value, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameIn(List<String> values) {
            addCriterion("system_name in", values, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameNotIn(List<String> values) {
            addCriterion("system_name not in", values, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameBetween(String value1, String value2) {
            addCriterion("system_name between", value1, value2, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemNameNotBetween(String value1, String value2) {
            addCriterion("system_name not between", value1, value2, "systemName");
            return (Criteria) this;
        }

        public Criteria andSystemTypeIsNull() {
            addCriterion("system_type is null");
            return (Criteria) this;
        }

        public Criteria andSystemTypeIsNotNull() {
            addCriterion("system_type is not null");
            return (Criteria) this;
        }

        public Criteria andSystemTypeEqualTo(String value) {
            addCriterion("system_type =", value, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeNotEqualTo(String value) {
            addCriterion("system_type <>", value, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeGreaterThan(String value) {
            addCriterion("system_type >", value, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeGreaterThanOrEqualTo(String value) {
            addCriterion("system_type >=", value, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeLessThan(String value) {
            addCriterion("system_type <", value, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeLessThanOrEqualTo(String value) {
            addCriterion("system_type <=", value, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeLike(String value) {
            addCriterion("system_type like", value, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeNotLike(String value) {
            addCriterion("system_type not like", value, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeIn(List<String> values) {
            addCriterion("system_type in", values, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeNotIn(List<String> values) {
            addCriterion("system_type not in", values, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeBetween(String value1, String value2) {
            addCriterion("system_type between", value1, value2, "systemType");
            return (Criteria) this;
        }

        public Criteria andSystemTypeNotBetween(String value1, String value2) {
            addCriterion("system_type not between", value1, value2, "systemType");
            return (Criteria) this;
        }

        public Criteria andBelongToIsNull() {
            addCriterion("belong_to is null");
            return (Criteria) this;
        }

        public Criteria andBelongToIsNotNull() {
            addCriterion("belong_to is not null");
            return (Criteria) this;
        }

        public Criteria andBelongToEqualTo(String value) {
            addCriterion("belong_to =", value, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToNotEqualTo(String value) {
            addCriterion("belong_to <>", value, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToGreaterThan(String value) {
            addCriterion("belong_to >", value, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToGreaterThanOrEqualTo(String value) {
            addCriterion("belong_to >=", value, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToLessThan(String value) {
            addCriterion("belong_to <", value, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToLessThanOrEqualTo(String value) {
            addCriterion("belong_to <=", value, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToLike(String value) {
            addCriterion("belong_to like", value, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToNotLike(String value) {
            addCriterion("belong_to not like", value, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToIn(List<String> values) {
            addCriterion("belong_to in", values, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToNotIn(List<String> values) {
            addCriterion("belong_to not in", values, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToBetween(String value1, String value2) {
            addCriterion("belong_to between", value1, value2, "belongTo");
            return (Criteria) this;
        }

        public Criteria andBelongToNotBetween(String value1, String value2) {
            addCriterion("belong_to not between", value1, value2, "belongTo");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipIsNull() {
            addCriterion("has_ownership is null");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipIsNotNull() {
            addCriterion("has_ownership is not null");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipEqualTo(Byte value) {
            addCriterion("has_ownership =", value, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipNotEqualTo(Byte value) {
            addCriterion("has_ownership <>", value, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipGreaterThan(Byte value) {
            addCriterion("has_ownership >", value, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipGreaterThanOrEqualTo(Byte value) {
            addCriterion("has_ownership >=", value, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipLessThan(Byte value) {
            addCriterion("has_ownership <", value, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipLessThanOrEqualTo(Byte value) {
            addCriterion("has_ownership <=", value, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipIn(List<Byte> values) {
            addCriterion("has_ownership in", values, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipNotIn(List<Byte> values) {
            addCriterion("has_ownership not in", values, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipBetween(Byte value1, Byte value2) {
            addCriterion("has_ownership between", value1, value2, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andHasOwnershipNotBetween(Byte value1, Byte value2) {
            addCriterion("has_ownership not between", value1, value2, "hasOwnership");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeIsNull() {
            addCriterion("network_type is null");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeIsNotNull() {
            addCriterion("network_type is not null");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeEqualTo(String value) {
            addCriterion("network_type =", value, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeNotEqualTo(String value) {
            addCriterion("network_type <>", value, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeGreaterThan(String value) {
            addCriterion("network_type >", value, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeGreaterThanOrEqualTo(String value) {
            addCriterion("network_type >=", value, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeLessThan(String value) {
            addCriterion("network_type <", value, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeLessThanOrEqualTo(String value) {
            addCriterion("network_type <=", value, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeLike(String value) {
            addCriterion("network_type like", value, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeNotLike(String value) {
            addCriterion("network_type not like", value, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeIn(List<String> values) {
            addCriterion("network_type in", values, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeNotIn(List<String> values) {
            addCriterion("network_type not in", values, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeBetween(String value1, String value2) {
            addCriterion("network_type between", value1, value2, "networkType");
            return (Criteria) this;
        }

        public Criteria andNetworkTypeNotBetween(String value1, String value2) {
            addCriterion("network_type not between", value1, value2, "networkType");
            return (Criteria) this;
        }

        public Criteria andDevLanguageIsNull() {
            addCriterion("dev_language is null");
            return (Criteria) this;
        }

        public Criteria andDevLanguageIsNotNull() {
            addCriterion("dev_language is not null");
            return (Criteria) this;
        }

        public Criteria andDevLanguageEqualTo(String value) {
            addCriterion("dev_language =", value, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageNotEqualTo(String value) {
            addCriterion("dev_language <>", value, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageGreaterThan(String value) {
            addCriterion("dev_language >", value, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageGreaterThanOrEqualTo(String value) {
            addCriterion("dev_language >=", value, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageLessThan(String value) {
            addCriterion("dev_language <", value, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageLessThanOrEqualTo(String value) {
            addCriterion("dev_language <=", value, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageLike(String value) {
            addCriterion("dev_language like", value, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageNotLike(String value) {
            addCriterion("dev_language not like", value, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageIn(List<String> values) {
            addCriterion("dev_language in", values, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageNotIn(List<String> values) {
            addCriterion("dev_language not in", values, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageBetween(String value1, String value2) {
            addCriterion("dev_language between", value1, value2, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andDevLanguageNotBetween(String value1, String value2) {
            addCriterion("dev_language not between", value1, value2, "devLanguage");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountIsNull() {
            addCriterion("interface_count is null");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountIsNotNull() {
            addCriterion("interface_count is not null");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountEqualTo(Integer value) {
            addCriterion("interface_count =", value, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountNotEqualTo(Integer value) {
            addCriterion("interface_count <>", value, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountGreaterThan(Integer value) {
            addCriterion("interface_count >", value, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("interface_count >=", value, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountLessThan(Integer value) {
            addCriterion("interface_count <", value, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountLessThanOrEqualTo(Integer value) {
            addCriterion("interface_count <=", value, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountIn(List<Integer> values) {
            addCriterion("interface_count in", values, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountNotIn(List<Integer> values) {
            addCriterion("interface_count not in", values, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountBetween(Integer value1, Integer value2) {
            addCriterion("interface_count between", value1, value2, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andInterfaceCountNotBetween(Integer value1, Integer value2) {
            addCriterion("interface_count not between", value1, value2, "interfaceCount");
            return (Criteria) this;
        }

        public Criteria andDeadlineIsNull() {
            addCriterion("deadline is null");
            return (Criteria) this;
        }

        public Criteria andDeadlineIsNotNull() {
            addCriterion("deadline is not null");
            return (Criteria) this;
        }

        public Criteria andDeadlineEqualTo(Date value) {
            addCriterion("deadline =", value, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineNotEqualTo(Date value) {
            addCriterion("deadline <>", value, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineGreaterThan(Date value) {
            addCriterion("deadline >", value, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineGreaterThanOrEqualTo(Date value) {
            addCriterion("deadline >=", value, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineLessThan(Date value) {
            addCriterion("deadline <", value, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineLessThanOrEqualTo(Date value) {
            addCriterion("deadline <=", value, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineIn(List<Date> values) {
            addCriterion("deadline in", values, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineNotIn(List<Date> values) {
            addCriterion("deadline not in", values, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineBetween(Date value1, Date value2) {
            addCriterion("deadline between", value1, value2, "deadline");
            return (Criteria) this;
        }

        public Criteria andDeadlineNotBetween(Date value1, Date value2) {
            addCriterion("deadline not between", value1, value2, "deadline");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserIsNull() {
            addCriterion("rqrmnt_user is null");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserIsNotNull() {
            addCriterion("rqrmnt_user is not null");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserEqualTo(String value) {
            addCriterion("rqrmnt_user =", value, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserNotEqualTo(String value) {
            addCriterion("rqrmnt_user <>", value, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserGreaterThan(String value) {
            addCriterion("rqrmnt_user >", value, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserGreaterThanOrEqualTo(String value) {
            addCriterion("rqrmnt_user >=", value, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserLessThan(String value) {
            addCriterion("rqrmnt_user <", value, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserLessThanOrEqualTo(String value) {
            addCriterion("rqrmnt_user <=", value, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserLike(String value) {
            addCriterion("rqrmnt_user like", value, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserNotLike(String value) {
            addCriterion("rqrmnt_user not like", value, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserIn(List<String> values) {
            addCriterion("rqrmnt_user in", values, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserNotIn(List<String> values) {
            addCriterion("rqrmnt_user not in", values, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserBetween(String value1, String value2) {
            addCriterion("rqrmnt_user between", value1, value2, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andRqrmntUserNotBetween(String value1, String value2) {
            addCriterion("rqrmnt_user not between", value1, value2, "rqrmntUser");
            return (Criteria) this;
        }

        public Criteria andContact1IsNull() {
            addCriterion("contact1 is null");
            return (Criteria) this;
        }

        public Criteria andContact1IsNotNull() {
            addCriterion("contact1 is not null");
            return (Criteria) this;
        }

        public Criteria andContact1EqualTo(String value) {
            addCriterion("contact1 =", value, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1NotEqualTo(String value) {
            addCriterion("contact1 <>", value, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1GreaterThan(String value) {
            addCriterion("contact1 >", value, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1GreaterThanOrEqualTo(String value) {
            addCriterion("contact1 >=", value, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1LessThan(String value) {
            addCriterion("contact1 <", value, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1LessThanOrEqualTo(String value) {
            addCriterion("contact1 <=", value, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1Like(String value) {
            addCriterion("contact1 like", value, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1NotLike(String value) {
            addCriterion("contact1 not like", value, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1In(List<String> values) {
            addCriterion("contact1 in", values, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1NotIn(List<String> values) {
            addCriterion("contact1 not in", values, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1Between(String value1, String value2) {
            addCriterion("contact1 between", value1, value2, "contact1");
            return (Criteria) this;
        }

        public Criteria andContact1NotBetween(String value1, String value2) {
            addCriterion("contact1 not between", value1, value2, "contact1");
            return (Criteria) this;
        }

        public Criteria andPhone1IsNull() {
            addCriterion("phone1 is null");
            return (Criteria) this;
        }

        public Criteria andPhone1IsNotNull() {
            addCriterion("phone1 is not null");
            return (Criteria) this;
        }

        public Criteria andPhone1EqualTo(String value) {
            addCriterion("phone1 =", value, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1NotEqualTo(String value) {
            addCriterion("phone1 <>", value, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1GreaterThan(String value) {
            addCriterion("phone1 >", value, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1GreaterThanOrEqualTo(String value) {
            addCriterion("phone1 >=", value, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1LessThan(String value) {
            addCriterion("phone1 <", value, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1LessThanOrEqualTo(String value) {
            addCriterion("phone1 <=", value, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1Like(String value) {
            addCriterion("phone1 like", value, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1NotLike(String value) {
            addCriterion("phone1 not like", value, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1In(List<String> values) {
            addCriterion("phone1 in", values, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1NotIn(List<String> values) {
            addCriterion("phone1 not in", values, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1Between(String value1, String value2) {
            addCriterion("phone1 between", value1, value2, "phone1");
            return (Criteria) this;
        }

        public Criteria andPhone1NotBetween(String value1, String value2) {
            addCriterion("phone1 not between", value1, value2, "phone1");
            return (Criteria) this;
        }

        public Criteria andContact2IsNull() {
            addCriterion("contact2 is null");
            return (Criteria) this;
        }

        public Criteria andContact2IsNotNull() {
            addCriterion("contact2 is not null");
            return (Criteria) this;
        }

        public Criteria andContact2EqualTo(String value) {
            addCriterion("contact2 =", value, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2NotEqualTo(String value) {
            addCriterion("contact2 <>", value, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2GreaterThan(String value) {
            addCriterion("contact2 >", value, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2GreaterThanOrEqualTo(String value) {
            addCriterion("contact2 >=", value, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2LessThan(String value) {
            addCriterion("contact2 <", value, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2LessThanOrEqualTo(String value) {
            addCriterion("contact2 <=", value, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2Like(String value) {
            addCriterion("contact2 like", value, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2NotLike(String value) {
            addCriterion("contact2 not like", value, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2In(List<String> values) {
            addCriterion("contact2 in", values, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2NotIn(List<String> values) {
            addCriterion("contact2 not in", values, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2Between(String value1, String value2) {
            addCriterion("contact2 between", value1, value2, "contact2");
            return (Criteria) this;
        }

        public Criteria andContact2NotBetween(String value1, String value2) {
            addCriterion("contact2 not between", value1, value2, "contact2");
            return (Criteria) this;
        }

        public Criteria andPhone2IsNull() {
            addCriterion("phone2 is null");
            return (Criteria) this;
        }

        public Criteria andPhone2IsNotNull() {
            addCriterion("phone2 is not null");
            return (Criteria) this;
        }

        public Criteria andPhone2EqualTo(String value) {
            addCriterion("phone2 =", value, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2NotEqualTo(String value) {
            addCriterion("phone2 <>", value, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2GreaterThan(String value) {
            addCriterion("phone2 >", value, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2GreaterThanOrEqualTo(String value) {
            addCriterion("phone2 >=", value, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2LessThan(String value) {
            addCriterion("phone2 <", value, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2LessThanOrEqualTo(String value) {
            addCriterion("phone2 <=", value, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2Like(String value) {
            addCriterion("phone2 like", value, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2NotLike(String value) {
            addCriterion("phone2 not like", value, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2In(List<String> values) {
            addCriterion("phone2 in", values, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2NotIn(List<String> values) {
            addCriterion("phone2 not in", values, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2Between(String value1, String value2) {
            addCriterion("phone2 between", value1, value2, "phone2");
            return (Criteria) this;
        }

        public Criteria andPhone2NotBetween(String value1, String value2) {
            addCriterion("phone2 not between", value1, value2, "phone2");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportIsNull() {
            addCriterion("need_platform_support is null");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportIsNotNull() {
            addCriterion("need_platform_support is not null");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportEqualTo(String value) {
            addCriterion("need_platform_support =", value, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportNotEqualTo(String value) {
            addCriterion("need_platform_support <>", value, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportGreaterThan(String value) {
            addCriterion("need_platform_support >", value, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportGreaterThanOrEqualTo(String value) {
            addCriterion("need_platform_support >=", value, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportLessThan(String value) {
            addCriterion("need_platform_support <", value, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportLessThanOrEqualTo(String value) {
            addCriterion("need_platform_support <=", value, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportLike(String value) {
            addCriterion("need_platform_support like", value, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportNotLike(String value) {
            addCriterion("need_platform_support not like", value, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportIn(List<String> values) {
            addCriterion("need_platform_support in", values, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportNotIn(List<String> values) {
            addCriterion("need_platform_support not in", values, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportBetween(String value1, String value2) {
            addCriterion("need_platform_support between", value1, value2, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andNeedPlatformSupportNotBetween(String value1, String value2) {
            addCriterion("need_platform_support not between", value1, value2, "needPlatformSupport");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIsNull() {
            addCriterion("category_id is null");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIsNotNull() {
            addCriterion("category_id is not null");
            return (Criteria) this;
        }

        public Criteria andCategoryIdEqualTo(Long value) {
            addCriterion("category_id =", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotEqualTo(Long value) {
            addCriterion("category_id <>", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdGreaterThan(Long value) {
            addCriterion("category_id >", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdGreaterThanOrEqualTo(Long value) {
            addCriterion("category_id >=", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdLessThan(Long value) {
            addCriterion("category_id <", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdLessThanOrEqualTo(Long value) {
            addCriterion("category_id <=", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIn(List<Long> values) {
            addCriterion("category_id in", values, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotIn(List<Long> values) {
            addCriterion("category_id not in", values, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdBetween(Long value1, Long value2) {
            addCriterion("category_id between", value1, value2, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotBetween(Long value1, Long value2) {
            addCriterion("category_id not between", value1, value2, "categoryId");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteIsNull() {
            addCriterion("expected_quote is null");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteIsNotNull() {
            addCriterion("expected_quote is not null");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteEqualTo(BigDecimal value) {
            addCriterion("expected_quote =", value, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteNotEqualTo(BigDecimal value) {
            addCriterion("expected_quote <>", value, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteGreaterThan(BigDecimal value) {
            addCriterion("expected_quote >", value, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("expected_quote >=", value, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteLessThan(BigDecimal value) {
            addCriterion("expected_quote <", value, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteLessThanOrEqualTo(BigDecimal value) {
            addCriterion("expected_quote <=", value, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteIn(List<BigDecimal> values) {
            addCriterion("expected_quote in", values, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteNotIn(List<BigDecimal> values) {
            addCriterion("expected_quote not in", values, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("expected_quote between", value1, value2, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andExpectedQuoteNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("expected_quote not between", value1, value2, "expectedQuote");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}